Bug 498221 - when joining cluster, new nodes create all queues as durable
when joining cluster, new nodes create all queues as durable
Status: CLOSED ERRATA
Product: Red Hat Enterprise MRG
Classification: Red Hat
Component: qpid-cpp (Show other bugs)
1.1.1
All Linux
urgent Severity high
: 1.1.2
: ---
Assigned To: mick
Jan Sarenik
:
Depends On: 503025
Blocks:
  Show dependency treegraph
 
Reported: 2009-04-29 09:59 EDT by Gordon Sim
Modified: 2009-06-12 13:39 EDT (History)
1 user (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2009-06-12 13:39:18 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
Fix (created against r752581) (9.97 KB, patch)
2009-05-27 10:25 EDT, Gordon Sim
no flags Details | Diff

  None (edit)
Description Gordon Sim 2009-04-29 09:59:19 EDT
Description of problem:

New members of a cluster convert all queues whose definitions they receive via the state update to durable queues.

Version-Release number of selected component (if applicable):

qpidd-0.5.752581-5.el5

How reproducible:

100%

Steps to Reproduce:
1. start first cluster node
2. create non durable queue (e.g. qpid-config -a host1:port1 add queue non-durable)
3. check queue status (e.g. qpid-config -a host1:port1 queues), queue is non-durable
4. start new node for same cluster
5. check queue status on new node (e.g. qpid-config -a host2:port2 queues)
  
Actual results:

Queue on second node is now durable.

Expected results:

Queue should be non-durable on both nodes.

Additional info:

If you have a node joining when clients are active, the failover exchange subscription queue (and indeed any temporary queues that are defined) are replicated to the new node as durable queues which then remain until manually deleted.
Comment 1 Jan Sarenik 2009-05-12 05:03:27 EDT
Reproduced on RHEL5.3 i386.

Related packages (mrg-devel repo):
 qpidd-cluster-0.5.752581-5.el5
 qpidd-0.5.752581-5.el5
 openais-0.80.3-22.el5_3.4

Waiting for new packages to verify.
Comment 2 Gordon Sim 2009-05-18 08:51:49 EDT
This is a result of the encode/decode logic in qpid/broker/Queue.cpp not being updated to include flags (previously it was only used for durable queues so the durable and exclusive flags were implied).
Comment 3 Gordon Sim 2009-05-27 10:25:57 EDT
Created attachment 345616 [details]
Fix (created against r752581)

Fixed on trunk by r779183; attached as a patch against r752581).
Comment 4 Gordon Sim 2009-05-28 06:18:20 EDT
Fixed in qpidd-0.5.752581-8
Comment 5 Jan Sarenik 2009-05-28 07:41:58 EDT
Using 'qpid-config' from package
python-qpid-0.5.752581-1.el5 to trigger the bug.

Reproducible on MRG 1.1.1 (mrg-stable):
  qpidd-0.5.752581-5.el5
  qpidd-cluster-0.5.752581-5.el5

I was about to try verifying it on:
  qpidd-0.5.752581-8.el5.i386.rpm
  qpidd-cluster-0.5.752581-8.el5.i386.rpm

But I can not continue until newly discovored
bug 503025 is fixed.
Comment 6 Jan Sarenik 2009-05-29 10:00:24 EDT
Verified on -9, RHEL5.3 i386.

I will test x86_64 soon.
Comment 7 Jan Sarenik 2009-06-01 03:18:37 EDT
Verified on qpidd-0.5.752581-10.el5 RHEL 5.3 x86_64
Comment 8 Jan Sarenik 2009-06-01 07:14:09 EDT
Verified again on RHEL5.3 i386 but qpidd-0.5.752581-10.el5 series.
Comment 10 errata-xmlrpc 2009-06-12 13:39:18 EDT
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on therefore solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.

http://rhn.redhat.com/errata/RHBA-2009-1097.html

Note You need to log in before you can comment on or make changes to this bug.